implemented backup and restore routines
[bash-notes.git] / notes.sh
1 #! /bin/bash
2
3 # bash-notes © 2023 by danix is licensed under CC BY-NC 4.0.
4 # To view a copy of this license, visit http://creativecommons.org/licenses/by-nc/4.0/
5
6 # to debug the script run it like:
7 # DEBUG=true notes.sh ...
8 # and check /tmp/debug_bash-notes.log
9 if [[ $DEBUG == true ]]; then
10 exec 5> /tmp/debug_bash-notes.log
11 BASH_XTRACEFD="5"
12 PS4='$LINENO: '
13 set -x
14 fi
15
16 PID=$$
17 BASENAME=$( basename "$0" )
18 NOW=$(date +%s)
19
20 VERSION="0.3"
21 DBVERSION=${VERSION}_${NOW}
22
23 set_defaults() {
24 # Binaries to use
25 JQ=${JQ:-/usr/bin/jq}
26 EDITOR=${EDITOR:-/usr/bin/vim}
27 TERMINAL=${TERMINAL:-/usr/bin/alacritty}
28 # add options for your terminal. Remember to add the last option to execute
29 # your editor program, otherwise the script will fail.
30 # see example in the addnote function
31 TERM_OPTS="--class notes --title notes -e "
32 # Setting PAGER here overrides whatever is set in your default shell
33 # comment this option to use your default pager if set in your shell.
34 PAGER=${PAGER:-/usr/bin/more}
35
36 # set this to true to have output in plain text
37 # or use the -p option on the command line before every other option
38 PLAIN=false
39 # base directory for program files
40 BASEDIR=${BASEDIR:-~/.local/share/bash-notes}
41 # notes database in json format
42 DB=${BASEDIR}/db.json
43 # directory containing the actual notes
44 NOTESDIR=${BASEDIR}/notes
45
46 } # end set_defaults, do not change this line.
47
48 set_defaults
49
50 # Do not edit below this point
51 RCFILE=${RCFILE:-~/.config/bash-notes.rc}
52 TMPDB=/tmp/db.json
53
54 if [ ! -x "$JQ" ]; then
55 echo "jq not found in your PATH"
56 echo "install jq to continue"
57 exit 1
58 fi
59
60 # IMPORT USER DEFINED OPTIONS IF ANY
61 if [[ -f $RCFILE ]]; then
62 # shellcheck disable=SC1090
63 source "$RCFILE"
64 fi
65
66 # We prevent the program from running more than one instance:
67 PIDFILE=/var/tmp/$(basename "$0" .sh).pid
68
69 # Make sure the PID file is removed when we kill the process
70 trap 'rm -f $PIDFILE; exit 1' TERM INT
71
72 if [[ -r $PIDFILE ]]; then
73 # PIDFILE exists, so I guess there's already an instance running
74 # let's kill it and run again
75 # shellcheck disable=SC2046,SC2086
76 kill -s 15 $(cat $PIDFILE) > /dev/null 2>&1
77 # should already be deleted by trap, but just to be sure
78 rm "$PIDFILE"
79 fi
80
81 # create PIDFILE
82 echo $PID > "$PIDFILE"
83
84 # Export config to file
85 function export_config() {
86 if [ -r ${RCFILE} ]; then
87 echo "Backing up current '${RCFILE}'...."
88 mv -f ${RCFILE} ${RCFILE}.$(date +%Y%m%d_%H%M)
89 fi
90 echo "Writing '${RCFILE}'...."
91 sed -n '/^set_defaults() {/,/^} # end set_defaults, do not change this line./p' $0 \
92 | grep -v set_defaults \
93 | sed -e 's/^\([^=]*\)=\${\1:-\([^}]*\)}/\1=\2/' \
94 > ${RCFILE}
95 if [ -r ${RCFILE} ]; then
96 echo "Taking no further action."
97 exit 0
98 else
99 echo "Could not write '${RCFILE}'...!"
100 exit 1
101 fi
102 }
103
104 # we should expand on this function to add a sample note and explain a little bit
105 # how the program works.
106 function firstrun() {
107 [ -f $RCFILE ] && RC=$RCFILE || RC="none"
108
109 clear
110 echo "${BASENAME} configuration:
111
112 base directory: ${BASEDIR}/
113 notes archive: ${NOTESDIR}/
114 notes database: ${DB}
115 rc file: $RC
116 text editor: ${EDITOR}
117 terminal: ${TERMINAL}
118 jq executable: ${JQ}
119 "
120
121 echo "Now I'll create the needed files and directories."
122 read -r -p "Do you wish to continue? (y/N) " ANSWER
123 case $ANSWER in
124 y|Y )
125 mkdir -p $NOTESDIR
126 cat << __EOL__ > ${DB}
127 {
128 "params": {
129 "version": "${VERSION}",
130 "dbversion": "${DBVERSION}"
131 },
132 "notes": []
133 }
134 __EOL__
135 echo; echo "All done, you can now write your first note."
136 ;;
137 * )
138 echo "No changes made. Exiting"
139 exit
140 ;;
141 esac
142 }
143
144 # check for notes dir existance and create it in case it doesn't exists
145 if [[ ! -d $NOTESDIR ]]; then
146 # we don't have a directory. FIRST RUN?
147 firstrun
148 fi
149 # check if input is a number, returns false or the number itself
150 function check_noteID() {
151 IN=$1
152 case $IN in
153 ''|*[!0-9]*)
154 return 1
155 ;;
156 *)
157 echo "$IN"
158 ;;
159 esac
160 }
161
162 function helptext() {
163 echo "Usage:"
164 echo " $0 [PARAMS] ..."
165 echo ""
166 echo "${BASENAME} parameters are:"
167 echo -e " -h | --help\t\t\t: This help text"
168 echo -e " -p | --plain\t\t\t: Output is in plain text"
169 echo -e "\t\t\t\t (without this option the output is formatted)"
170 echo -e "\t\t\t\t (this option must precede all others)"
171 echo -e " -l | --list\t\t\t: List existing notes"
172 echo -e " -a | --add=[\"<title>\"]\t: Add new note"
173 echo -e " -e | --edit=[<note>]\t\t: Edit note"
174 echo -e " -d | --delete=[<note> | all] : Delete single note or all notes at once"
175 echo -e " -s | --show=[<note>]\t\t: Display note using your favourite PAGER"
176 echo -e " -r | --restore=[<dir>]\t: Restore a previous backup from dir"
177 echo -e " -v | --version\t\t: Print version"
178 echo -e " --userconf\t\t\t: Export User config file"
179 echo -e " --backup [<dest>]\t\t: Backup your data in your destination folder"
180 echo ""
181 }
182
183 function configtext() {
184 cat << __NOWCONF__
185 ${BASENAME} configuration is:
186
187 base directory: ${BASEDIR}/
188 notes archive: ${NOTESDIR}/
189 notes database: ${DB}
190 rc file: $RCFILE
191 debug file: /tmp/debug_bash-note.log
192
193 text editor: ${EDITOR}
194 terminal: ${TERMINAL}
195 jq executable: ${JQ}
196 PAGER: ${PAGER}
197 __NOWCONF__
198
199 }
200
201 function addnote() {
202 # remove eventually existing temp DB file
203 if [[ -f $TMPDB ]]; then
204 rm $TMPDB
205 fi
206
207 NOTETITLE="$1"
208 echo "adding new note - \"$NOTETITLE\""
209 # shellcheck disable=SC2086
210 LASTID=$($JQ '.notes[-1].id // 0 | tonumber' $DB)
211 # [ "" == $LASTID ] && LASTID=0
212 NOTEID=$(( LASTID + 1 ))
213 # shellcheck disable=SC2086
214 touch ${NOTESDIR}/${NOW}
215 # shellcheck disable=SC2016
216 $JQ --arg i "$NOTEID" --arg t "$NOTETITLE" --arg f "$NOW" '.notes += [{"id": $i, "title": $t, "file": $f}]' "$DB" > $TMPDB
217 # shellcheck disable=SC2086
218 mv $TMPDB $DB
219 # example for alacritty:
220 # alacritty --class notes --title notes -e /usr/bin/vim ...
221 # shellcheck disable=SC2086,SC2091
222 $(${TERMINAL} ${TERM_OPTS} ${EDITOR} ${NOTESDIR}/${NOW})
223 }
224 function backup_data() {
225 BACKUPDIR="$1"
226 echo "backing up data in $BACKUPDIR"
227
228
229 if [ -d $BACKUPDIR ]; then
230 if [ $(/bin/ls -A $BACKUPDIR) ]; then
231 echo "$BACKUPDIR is not empty. Cannot continue"
232 exit
233 else
234 echo "$BACKUPDIR is ok. Continuing!"
235 fi
236 else
237 # BACKUPDIR doesn't exists
238 echo "$BACKUPDIR doesn't exists"
239 read -r -p "Do you want me to create it for you? (y/N) " ANSWER
240 case $ANSWER in
241 y|Y )
242 mkdir -p $BACKUPDIR
243 ;;
244 * )
245 echo "No changes made. Exiting"
246 exit
247 ;;
248 esac
249 fi
250 # ok, we have a backup directory
251 if [ -r $RCFILE ]; then
252 BCKUP_COMM=$(rsync -avz --progress ${RCFILE}* ${BASEDIR}/* ${BACKUPDIR})
253 else
254 BCKUP_COMM=$(rsync -avz --progress ${BASEDIR}/* ${BACKUPDIR})
255 fi
256 # run the command
257 if [ "$BCKUP_COMM" ]; then
258 echo -e "All files backed up."
259 echo -e "BACKUP directory:\t$BACKUPDIR"
260 tree $BACKUPDIR | $PAGER
261 echo; echo "BACKUP COMPLETED"
262 fi
263 }
264
265 function backup_restore() {
266 BACKUPDIR="$1"
267 echo "restoring backup from $BACKUPDIR"
268 echo "This will overwrite all your notes and configurations with the backup."
269 read -r -p "Do you want to continue? (y/N) " ANSWER
270 case $ANSWER in
271 y|Y )
272 # restoring rc file
273 BACKUPRC=$(basename $RCFILE)
274 if [ -r ${BACKUPDIR}/${BACKUPRC} ]; then
275 if [ -r ${RCFILE} ]; then
276 echo "Backing up current '${RCFILE}'...."
277 mv -f ${RCFILE} ${RCFILE}.$(date +%Y%m%d_%H%M)
278 fi
279 cp --verbose ${BACKUPDIR}/${BACKUPRC} $RCFILE
280 fi
281 # restoring notes directory
282 if [ -d $BACKUPDIR/notes ]; then
283 if [ $(/bin/ls -A $NOTESDIR) ]; then
284 rm --verbose $NOTESDIR/*
285 fi
286 cp -r --verbose $BACKUPDIR/notes $BASEDIR
287 fi
288 # restoring database
289 BACKUPDB=$(basename $DB)
290 if [ -f ${BACKUPDIR}/${BACKUPDB} ]; then
291 if [ -r ${DB} ]; then
292 echo "Backing up current '${DB}'...."
293 mv -f ${DB} ${DB}.$(date +%Y%m%d_%H%M)
294 fi
295 cp --verbose ${BACKUPDIR}/${BACKUPDB} $DB
296 fi
297 ;;
298 * )
299 echo "No changes made. Exiting"
300 exit
301 ;;
302 esac
303 }
304
305 function editnote() {
306 NOTE=$1
307 # shellcheck disable=SC2155
308 local OK=$(check_noteID "$NOTE")
309 if [ ! "$OK" ]; then
310 echo "invalid note \"$NOTE\""
311 echo "Use the note ID that you can fetch after listing your notes"
312 exit 1
313 fi
314
315 # shellcheck disable=SC2016,SC2086
316 TITLE=$($JQ --arg i $OK '.notes[] | select(.id == $i) | .title' $DB)
317 # shellcheck disable=SC2016,SC2086
318 FILE=$($JQ -r --arg i $OK '.notes[] | select(.id == $i) | .file' $DB)
319 if [ "$TITLE" ]; then
320 echo "editing note $TITLE"
321 # shellcheck disable=SC2086,SC2091
322 $(${TERMINAL} ${TERM_OPTS} ${EDITOR} ${NOTESDIR}/${FILE})
323 else
324 echo "note not found"
325 exit 1
326 fi
327 }
328 function listnotes() {
329 # [ $PLAIN == true ] && echo "output is plain text" || echo "output is colored"
330 if [[ $(ls -A "$NOTESDIR") ]]; then
331 if [ $PLAIN == false ]; then
332 echo "listing all notes"
333 echo ""
334 fi
335 [ $PLAIN == false ] && echo "[ID] [TITLE] [CREATED]"
336 for i in "${NOTESDIR}"/*; do
337 # shellcheck disable=SC2155
338 local fname=$(basename $i)
339 DATE=$(date -d @${fname} +"%d/%m/%Y %R %z%Z")
340 # shellcheck disable=SC2016,SC2086
341 TITLE=$($JQ -r --arg z $(basename $i) '.notes[] | select(.file == $z) | .title' $DB)
342 # shellcheck disable=SC2016,SC2086
343 ID=$($JQ -r --arg z $(basename $i) '.notes[] | select(.file == $z) | .id' $DB)
344 [ $PLAIN == false ] && echo "[${ID}] ${TITLE} ${DATE}" || echo "${ID} - ${TITLE} - ${DATE}"
345 done
346 else
347 echo "no notes yet. You can add your first one with: ${BASENAME} -a \"your note title\""
348 fi
349 }
350 function rmnote() {
351 # remove eventually existing temp DB file
352 if [[ -f $TMPDB ]]; then
353 rm $TMPDB
354 fi
355
356 NOTE=$1
357 if [ "all" == "$NOTE" ]; then
358 echo "You're going to delete all notes."
359 read -r -p "Do you wish to continue? (y/N) " ANSWER
360 case $ANSWER in
361 y|Y )
362 # shellcheck disable=SC2086
363 $JQ 'del(.notes[])' $DB > $TMPDB
364 # shellcheck disable=SC2086
365 mv $TMPDB $DB
366 # shellcheck disable=SC2086
367 rm $NOTESDIR/*
368 echo "Deleted all notes"
369 ;;
370 * )
371 echo "Aborting, no notes were deleted."
372 exit 1
373 ;;
374 esac
375 else
376 # shellcheck disable=SC2155
377 local OK=$(check_noteID "$NOTE")
378 if [ ! "$OK" ]; then
379 echo "invalid note \"$NOTE\""
380 echo "Use the note ID that you can fetch after listing your notes"
381 exit 1
382 fi
383
384 # shellcheck disable=SC2016,SC2086
385 TITLE=$($JQ --arg i $OK '.notes[] | select(.id == $i) | .title' $DB)
386 # shellcheck disable=SC2016,SC2086
387 FILE=$($JQ -r --arg i $OK '.notes[] | select(.id == $i) | .file' $DB)
388 if [ "$TITLE" ]; then
389 # shellcheck disable=SC2016,SC2086
390 $JQ -r --arg i $OK 'del(.notes[] | select(.id == $i))' $DB > $TMPDB
391 # shellcheck disable=SC2086
392 mv $TMPDB $DB
393 rm $NOTESDIR/$FILE
394 echo "Deleted note $TITLE"
395 else
396 echo "note not found"
397 exit 1
398 fi
399 fi
400 }
401 function shownote() {
402 NOTE=$1
403
404 # shellcheck disable=SC2155
405 local OK=$(check_noteID "$NOTE")
406 if [ ! "$OK" ]; then
407 echo "invalid note \"$NOTE\""
408 echo "Use the note ID that you can fetch after listing your notes"
409 exit 1
410 fi
411
412 FILE=$($JQ -r --arg i $OK '.notes[] | select(.id == $i) | .file' $DB)
413
414 if [ "$FILE" ]; then
415 $PAGER ${NOTESDIR}/${FILE}
416 fi
417 }
418 # shellcheck disable=SC2006
419 GOPT=$(getopt -o hvplr::a::e::d::s:: --long help,version,list,plain,userconf,restore::,backup::,add::,edit::,delete::,show:: -n 'bash-notes' -- "$@")
420
421 # shellcheck disable=SC2181
422 if [ $? != 0 ] ; then helptext >&2 ; exit 1 ; fi
423
424 # Note the quotes around `$GOPT': they are essential!
425 eval set -- "$GOPT"
426 unset GOPT
427
428 while true; do
429 case "$1" in
430 -h | --help )
431 helptext
432 exit
433 ;;
434 -v | --version )
435 echo $BASENAME v${VERSION}
436 exit
437 ;;
438 -p | --plain )
439 PLAIN=true
440 shift
441 ;;
442 -l | --list )
443 listnotes
444 exit
445 ;;
446 -a | --add )
447 case "$2" in
448 '' )
449 read -r -p "Title: " TITLE
450 ;;
451 * )
452 TITLE=$2
453 ;;
454 esac
455 shift 2
456 addnote "$TITLE"
457 exit
458 ;;
459 -e | --edit )
460 case "$2" in
461 '' )
462 read -r -p "Note ID: " NOTE
463 ;;
464 * )
465 NOTE=$2
466 ;;
467 esac
468 shift 2
469 editnote "$NOTE"
470 exit
471 ;;
472 -d | --delete )
473 case "$2" in
474 '' )
475 read -r -p "Note ID: " NOTE
476 ;;
477 * )
478 NOTE=$2
479 ;;
480 esac
481 shift 2
482 rmnote "$NOTE"
483 exit
484 ;;
485 -s | --show )
486 case "$2" in
487 '' )
488 read -r -p "Note ID: " NOTE
489 ;;
490 * )
491 NOTE=$2
492 ;;
493 esac
494 shift 2
495 shownote "$NOTE"
496 exit
497 ;;
498 -r | --restore )
499 case "$2" in
500 '' )
501 read -r -p "Backup Dir: " RDIR
502 ;;
503 * )
504 RDIR=$2
505 ;;
506 esac
507 shift 2
508 backup_restore $RDIR
509 exit
510 ;;
511 --userconf )
512 export_config
513 # shellcheck disable=SC2317
514 echo "config exported to \"$RCFILE\""
515 # shellcheck disable=SC2317
516 exit
517 ;;
518 --backup )
519 case "$2" in
520 '' )
521 read -r -p "Backup Dir: " BDIR
522 ;;
523 * )
524 BDIR=$2
525 ;;
526 esac
527 shift 2
528 backup_data $BDIR
529 exit
530 ;;
531 -- )
532 shift
533 break
534 ;;
535 * )
536 break
537 ;;
538 esac
539 done